# from .offscreen_context import OffscreenContext
import os

if os.environ.get("PYOPENGL_PLATFORM", None) == "egl":
    print("using egl")
    from .egl_offscreen_context import OffscreenContext
else:
    print("using glfw")
    from .glfw_offscreen_context import OffscreenContext
from .fbo import Framebuffer
from .renderbuffer import Renderbuffer, RenderbufferMultisample
from .texture import Texture, TextureMultisample, Texture1D, Texture3D
from .shader import Shader
from .shader_storage_buffer import ShaderStorage
from .vertexbuffer import Vertexbuffer
from .vao import VAO
from .ibo import IBO
from .ebo import EBO
from .camera import Camera
from .window import Window
from .material import Material
from . import geometry as geo
from .tiles import tiles, tiles4
